import sys
import operator
import xlrd
# import xlwt

class XLBOOK:

    def __init__(self, excelFile):
        self.book = xlrd.open_workbook(excelFile, formatting_info=True)
        self.excelFile = excelFile
        self.Set_Sheet_By_Number(0)

    # End of __Init__


    excelFile = ""
    book = ""
    sheet = "error"
    sheetNum = 1
    sheetName="error"
    row = 0
    col = 0
    cell = ""

    def Set_Sheet_By_Name(self,sheetName):

        ShowComments = False

        if (ShowComments):
            sys.stdout.write("XLBOOK - Set_Sheet_By_Name: sheetName = >" + str(sheetName) + "<\n")
            
        sheetNames = self.book.sheet_names()
        if (sheetName in sheetNames):

            self.sheet = self.book.sheet_by_name(sheetName)
            
            self.sheetName = sheetName
            sheetNames = self.book.sheet_names()
            self.sheetNum = sheetNames.index(sheetName)
            self.SetRow(0)
            self.SetCol(0)
        else:
            sys.stdout.write("XLBOOK - Set_Sheet_By_Name ERROR: sheetName not found book's list of sheets.  sheetNames = >" + str(sheetNames) + "<\n")
            sheetName = "ERROR"
            
        return sheetName

    # End of SetSheetByName
        

    def Set_Sheet_By_Number(self,sheetNum):

        ShowComments = False

        if (ShowComments):
            sys.stdout.write("XLBOOK - Set_Sheet_By_Name: sheetNum = >" + str(sheetNum) + "<\n")

        if ((sheetNum < 0) or (sheetNum > self.book.nsheets)):
            sys.stdout.write("XLBOOK - Set_Sheet_By_Name ERROR: sheetNum out of expected range.  self.book.nsheets = >" + self.book.nsheets + "<\n")
            sheetNum = -1

        else:
            self.sheet = self.book.sheet_by_index(sheetNum)
            sheetNames = self.book.sheet_names()
            self.sheetName = sheetNames[sheetNum - 1]
            self.sheetNum = sheetNum
            self.SetRow(0)
            self.SetCol(0)

        return sheetNum

    # End of SetSheetByNumber


    def SetRow(self,row):
        self.row = row
        self.cell = self.sheet.cell(self.row,self.col)
        return row

    # End of SetRow
    

    def SetCol(self,col):
        self.col = col
        self.cell = self.sheet.cell(self.row,self.col)
        return col
    

    def Find_Col_By_Value(self, value, row = -1):

        ShowComments = False

        if (ShowComments):
            sys.stdout.write("XLBOOK - Find_Col_By_Value: value = >" + str(value) + "< row = >"+ str(row) + "<\n")
            
        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        if (ShowComments):
            sys.stdout.write("XLBOOK - Find_Col_By_Value: row = >" + str(row) + "<\n")

        colList = self.Get_Horiz_Strip(row)

        if (ShowComments):
            sys.stdout.write("XLBOOK - Find_Col_By_Value: colList = >" + str(colList) + "<\n")
        
        col = -1
        
        valStr = str(value).strip()
        for i in range(0, (len(colList)-1)):
            colStr = str(colList[i].strip())
            if (valStr == colStr):
                col = i
                self.row = 0
                self.SetCol(col)

        if (ShowComments):
            sys.stdout.write("XLBOOK - Find_Col_By_Value: col = >" + str(col) + "<\n")
        return col

    # end Find_Col_By_Value


    def Find_Row_By_Value(self, value, col = -1):

        ShowComments = False

        if (ShowComments):
            sys.stdout.write("XLBOOK - Find_Row_By_Value: value = >" + str(value) + "< col = >"+ str(col) + "<\n")
            
        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        if (ShowComments):
            sys.stdout.write("XLBOOK - Find_Row_By_Value: col = >" + str(col) + "<\n")

        rowList = self.Get_Vert_Strip(col)

        if (ShowComments):
            sys.stdout.write("XLBOOK - Find_Row_By_Value: colList = >" + str(rowList) + "<\n")
        
        row = -1
        
        valStr = str(value).strip()
        for i in range(0, (len(rowList)-1)):
            rowStr = str(rowList[i]).strip()
            if (valStr == rowStr):
                row = i
                self.col = 0
                self.SetRow(row)

        if (ShowComments):
            sys.stdout.write("XLBOOK - Find_Row_By_Value: row = >" + str(row) + "<\n")
        return row

    # end Find_Row_By_Value


    def Get_Cell_Value(self, row=-1, col=-1):

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        cellValue = self.cell.value
        cellType = self.cell.ctype

        return cellValue

    # end of Get_Cell_Value


    def Get_Vert_Strip(self, col=-1, rowStart=-1, rowEnd = -1):

        if (rowStart != -1):
            rowStart = self.row
        else:
            rowStart = 0

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        if (rowEnd == -1):
             colList = self.sheet.col_values(col, rowStart)
        else:
             colList = self.sheet.col_values(col, rowStart, rowEnd)
        

        return colList
           

    # end of Get_Vert_Strip


    def Get_Horiz_Strip(self, row=-1, colStart=-1, colEnd = -1):

        if (colStart != -1):
            colStart = self.col
        else:
            colStart = 0

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row


        if (colEnd == -1):
             rowList = self.sheet.row_values(row, colStart)
        else:
             rowList = self.sheet.row_values(row, colStart, colEnd)
        

        return rowList
           

    # end of Get_Vert_Strip


    def XlColor_To_WebColor(self,xlColor):

        ShowComments = False

        if (ShowComments):
            sys.stdout.write("XlColor_To_WebColor: xlColor = >")
            sys.stdout.write(xlColor)
            sys.stdout.write("<\n")

        rgbProd = "#"
        for i in xlColor:
            rgbVal = hex(i).split("0x")[1]
            if (len(rgbVal) < 2):
                rgbVal = "0" + rgbVal
                
            rgbProd = rgbProd +rgbVal
            
            if (ShowComments):
                sys.stdout.write("XlColor_To_WebColor: i = >")
                sys.stdout.write(i)
                sys.stdout.write("<\n")
                sys.stdout.write("XlColor_To_WebColor: rgbProd = >")
                sys.stdout.write(rgbProd)
                sys.stdout.write("<\n")
            
        return rgbProd

    # End of XlColor_To_WebColor


    def Cell_Font_Color(self,row=-1,col=-1):

        ShowComments = False

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: starting row = >" + str(row) + "<\n")
            sys.stdout.write("Cell_Font_Color: starting col = >" + str(col) + "<\n")

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col
            
        book = self.book
        sheet = self.sheet
        cell = self.cell

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: row = >" + str(row) + "<\n")
            sys.stdout.write("Cell_Font_Color: col = >" + str(col) + "<\n")
            sys.stdout.write("Cell_Font_Color: cell.value = >" + str(cell.value) + "<\n")

    # Get to the XF info for the cell
        xfx = sheet.cell_xf_index(row,col)
        xf= book.xf_list[xfx]

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: xfx = >" + str(xfx) + "<\n")
            sys.stdout.write("Cell_Font_Color: xf.font_index = >" + str(xf.font_index) + "<\n")

    # Get font color info
        fontx = book.font_list[xf.font_index]
        fontRGB = book.colour_map[fontx.colour_index]

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: fontx.colour_index = >" + str(fontx.colour_index) + "<\n")
            sys.stdout.write("Cell_Font_Color: fontRGB = >" + str(fontRGB) + "<\n")

        if (fontRGB == None):
            fontRGB = (0, 0, 0)

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: fontRGB = >" + str(fontRGB) + "<\n")

    # Convert Excel RBG to web RGB
        return self.XlColor_To_WebColor(fontRGB)

    # end Cell_Font_Color


    def Cell_BG_Color(self,row=-1,col=-1):

        ShowComments = False

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: starting row = >" + str(row) + "<\n")
            sys.stdout.write("Cell_Font_Color: starting col = >" + str(col) + "<\n")

        if (row != -1):
            row = self.SetRow(row)
        else:
            row = self.row

        if (col != -1):
            col = self.SetCol(col)
        else:
            col = self.col

        book = self.book
        sheet = self.sheet
        cell = self.cell

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: row = >" + str(row) + "<\n")
            sys.stdout.write("Cell_Font_Color: col = >" + str(col) + "<\n")
            sys.stdout.write("Cell_Font_Color: cell.value = >" + str(cell.value) + "<\n")


    # Get to the XF info for the cell
        cell = sheet.cell(row,col)
        xfx = sheet.cell_xf_index(row,col)
        xf= book.xf_list[xfx]

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: xfx = >" + str(xfx) + "<\n")

    # Get background color info
        bgx = xf.background.pattern_colour_index
        bgRGB = book.colour_map[bgx]

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: bgx = >" + str(bgx) + "<\n")
            sys.stdout.write("Cell_Font_Color: bgRGB = >" + str(bgRGB) + "<\n")

        if (bgRGB == None):
            bgRGB = (255, 255, 255)

        if (ShowComments):
            sys.stdout.write("Cell_Font_Color: bgRGB = >" + str(bgRGB) + "<\n")

        return self.XlColor_To_WebColor(bgRGB)

    # end Get_BG_Color

# End of XLBook class
